#ifndef env_hpp
#define env_hpp

#include "pointer.hpp"

#include <string>

class Val;

class Env ENABLE_THIS(Env) {
public:
  virtual PTR(Val) lookup(std::string find_name) = 0;
  virtual bool equals(PTR(Env) other_env) = 0;
  
  static PTR(Env) empty;
};

class EmptyEnv : public Env {
public:
  EmptyEnv();
  bool equals(PTR(Env) other_env);
  PTR(Val) lookup(std::string find_name);
};

class ExtendedEnv : public Env {
public:
  std::string name;
  PTR(Val) val;
  PTR(Env) rest;
  ExtendedEnv(std::string name, PTR(Val) val, PTR(Env) rest);
  bool equals(PTR(Env) other_env);
  PTR(Val) lookup(std::string find_name);
};

#endif /* env_hpp */
