#include <iostream>
#include "parse.hpp"
#include "expr.hpp"
#include "value.hpp"
#include "env.hpp"

#define CATCH_CONFIG_RUNNER
#include "catch.hpp"

int main(int argc, char **argv) {
  try {
    PTR(Expr) e;
    bool optimize_mode;
    
    if ((argc > 1) && !strcmp(argv[1], "--opt")) {
      optimize_mode = true;
      argc--;
      argv++;
    } else
      optimize_mode = false;
    
    if (argc > 1) {
      std::ifstream prog_in(argv[1]);
      e = parse(prog_in);
    } else
      e = parse(std::cin);
    
    if (optimize_mode)
      std::cout << e->optimize()->to_string() << "\n";
    else
      std::cout << e->interp(Env::empty)->to_string() << "\n";
    return 0;
  } catch (std::runtime_error exn) {
    std::cerr << exn.what() << "\n";
    return 1;
  }
}
